// cxxclient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <comdef.h>
#import "C:\\Work\\Vb2Java.PassByValue\\people.tlb" no_namespace, raw_interfaces_only, named_guids

int main(int argc, char* argv[]) {
	CoInitialize(0);

   IPeopleFinder *pPeopleFinder = 0;
	HRESULT hr = 0;
	hr = CoCreateInstance(CLSID_PeopleFinder, 0, CLSCTX_ALL, 
							    IID_IPeopleFinder, (void**)&pPeopleFinder);
	if (FAILED(hr)) {
		printf("CoCreateInstance() failed.\n");
	} 
	
	VARIANT pOldest;
	hr = pPeopleFinder->getOldestPerson(&pOldest);
	if (FAILED(hr)) {
		printf("getOldestPerson() failed.\n");
	} 

	::MessageBox(0,"UNPLUG CONNECTION",NULL,0);

	ComIntrinsycTestPersonStruct* data;
	data = (ComIntrinsycTestPersonStruct*)pOldest.pvRecord;
	hr = SysStringByteLen(data->name);
	printf("Oldest person born was ");
	int i;
	for(i = 0; i < hr/2; i++)
		printf("%s", &data->name[i]);
	printf("\n");
	printf("Oldest person zip is %d\n", data->zip);

	::MessageBox(0,"PLUG CONNECTION BACK IN",NULL,0);

	VARIANT pAllPeople;
	hr = pPeopleFinder->getAllPeople(&pAllPeople);
	if (FAILED(hr)) {
		printf("getAllPeople() failed.\n");
	} 

	::MessageBox(0,"UNPLUG CONNECTION",NULL,0);

	long lStartBound = 0;
	long lEndBound = 0;
	long iIndex = 0;
	VARIANT result;
	SAFEARRAY* pSafeArray  = pAllPeople.parray;
	SafeArrayGetLBound(pSafeArray, 1, &lStartBound);
	SafeArrayGetUBound(pSafeArray, 1, &lEndBound);

	for(iIndex = lStartBound; iIndex <= lEndBound; iIndex ++) {
		hr = SafeArrayGetElement(pSafeArray, &iIndex, &result);
		data = (ComIntrinsycTestPersonStruct*)result.pvRecord;
		printf("Person %d has zip: %d\n", iIndex, data->zip);
	}

	SafeArrayDestroy(pSafeArray);
	
	::MessageBox(0,"PLUG CONNECTION BACK IN",NULL,0);

	pPeopleFinder->Release();
		
	return 0;
}

